
CoCoALib - Feature #1598

RingHom: implement phi(X) as apply(phi, X)  also for X vector and matrix

10 Jun 2021 18:09 - Anna Maria Bigatti

Status: Closed Start date: 10 Jun 2021

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: Improving Estimated time: 8.51 hours

Target version: CoCoALib-0.99800 Spent time: 8.15 hours

Description

phi(f) is equivalent to apply(phi, f).

Implement also for matrix and vector (and export it to CoCoA-5)

Related issues:

Related to CoCoA-5 - Design #1568: RMap and image: obsolescent? In Progress 22 Jan 2021

Related to CoCoALib - Feature #1602: Sparse matrix (SparseMat) New 02 Jul 2021

Related to CoCoALib - Bug #1601: Compilation ambiguity Closed 16 Jun 2021

Related to CoCoALib - Design #1467: Change syntax  apply(phi,M) into phi(M)? Closed 22 Jun 2020

History

#1 - 10 Jun 2021 18:09 - Anna Maria Bigatti

- Related to Design #1568: RMap and image: obsolescent? added

#2 - 21 Jun 2021 15:23 - John Abbott

- Status changed from New to In Progress

Do we still want to keep apply?

Or should it be moved to "obsolescent"?

#3 - 21 Jun 2021 15:30 - Anna Maria Bigatti

- Assignee set to Anna Maria Bigatti

I'll try doing it!

and think of other involved classes.

(and consider whether making apply obsolescent)

#4 - 21 Jun 2021 15:44 - Anna Maria Bigatti

See RingHom.[HC]

  RingElem PartialRingHom::operator()(ConstRefRingElem x) const

and copy/adapt it to other classes

#5 - 02 Jul 2021 17:27 - Anna Maria Bigatti
- % Done changed from 10 to 30

I made a prototype for matrix.  Needs to be tested properly.

#6 - 19 Jul 2021 14:17 - John Abbott

- Related to Feature #1602: Sparse matrix (SparseMat) added

#7 - 30 Jul 2021 17:30 - Anna Maria Bigatti

Added phi(matrix).

Prototype.  Not entirely certain with it.

CVS'd

#8 - 30 Jul 2021 19:31 - John Abbott

I have a prototype for list/vector; not checked, not checked-in.

Should I check it in?  Would you test it?

#9 - 03 Aug 2021 09:45 - Anna Maria Bigatti

- % Done changed from 30 to 50

John Abbott wrote:

I have a prototype for list/vector; not checked, not checked-in.

Should I check it in?  Would you test it?

 

Added test for phi(vector) in test-RingHom1.C (and consequent .out).

I wanted to run valgrind on it, but I don't have it installed and ValgrindTests.sh didn't tell me (??!?).

#10 - 03 Aug 2021 10:35 - John Abbott

I have updated ValgrindTests.sh --now it should give a helpful error mesg when valgrind is not installed (or not in your PATH).

Checked in!

#11 - 06 Aug 2021 08:44 - Anna Maria Bigatti

Implemented for vector also in CoCoA-5, where it'll be most useful.

It was much more painful than expected because of the old style on RINGHOM::eval in Interpreter.C.

At the end I've rewrittein it using evalArgAsT1orT2orT3orT4orT5orT6, switch, Value::from, RefTo... and it seems to work fine.

I also added a test in bug-EvalTwice.cocoa5 (OK)

#12 - 06 Aug 2021 08:44 - Anna Maria Bigatti

- Status changed from In Progress to Resolved

- % Done changed from 50 to 80
#13 - 14 Sep 2021 12:00 - John Abbott

The manual entry for "Intro to RingHom" needs to be updated.

Must also add some good tests, e.g.

phi := IdentityHom(R);

phi([1,2,3]);  -->  ***!!!CRASH!!!***  But should work, right?

#14 - 30 Sep 2021 14:09 - John Abbott

- Related to Bug #1601: Compilation ambiguity added

#15 - 04 Oct 2021 11:16 - John Abbott

- Related to Design #1615: apply: remove for RingHom added

#16 - 04 Oct 2021 12:00 - John Abbott

I am not sure whether the following behaviour is what is wanted:

phi := CanonicalHom(R);

phi([1,2,x]); --> works as one might hope; x is indet in R

phi([1,2,3]); --> ERROR: Argument to RingHom must be in domain

 

Should the second really give error?

#17 - 04 Oct 2021 12:03 - John Abbott

We should move towards making apply obsolescent in CoCoA-5 now that RINGHOM can be applied directly to LIST and MAT.

Many packages use apply, and several tests use apply too.

#18 - 13 Nov 2021 00:58 - John Abbott

We should update the doc so that it encourages people to apply RINGHOM directly rather than using apply.

We should also gradually removed uses of apply from the packages.

And, as written in the previous comment, make apply obsolescent.

#19 - 17 Feb 2022 20:07 - John Abbott

- Status changed from Resolved to Feedback

- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99800
- % Done changed from 80 to 90

I have now made apply obsolescent, and updated the doc.

Hopefully all is OK now...  I'd better run the tests (sigh).

#20 - 17 Feb 2022 20:28 - John Abbott

I have now removed apply from all the packages as well... sigh!

All tests pass now.

#21 - 18 Feb 2022 15:02 - Anna Maria Bigatti

- Related to Design #1467: Change syntax  apply(phi,M) into phi(M)? added

#22 - 18 Feb 2022 15:03 - Anna Maria Bigatti

This issue overlaps with Design #1467.

#23 - 18 Feb 2022 15:05 - Anna Maria Bigatti

- Related to deleted (Design #1615: apply: remove for RingHom)

#24 - 18 Feb 2022 15:24 - Anna Maria Bigatti

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 8.51 h
